//	Class header for a generic byte buffer

#pragma once

class CharBuffer 																											//	a buffer for reading / writing bytes
	{
	public:

////////////////////////////////////////////////////////////////////////
//									  																								//
//	Data members:																											//
//									  																								//
////////////////////////////////////////////////////////////////////////

	char *theData;																											//	pointer to the actual data
	char *readHead;																											//	where to read from
	char *writeHead;																										//	the point to which to add
	long maxSize;																												//	size of buffer allocated
	long size;																													//	number of bytes used so far
	
////////////////////////////////////////////////////////////////////////
//									  																								//
//	Exceptions:																												//
//									  																								//
////////////////////////////////////////////////////////////////////////

	class EndOfBufferHit {};																						//	exception when a Get hits the end of the buffer
	class OutOfMemory {};																								//	exception when we run out of memory

////////////////////////////////////////////////////////////////////////
//									  																								//
//	Member Functions:  																								//
//									  																								//
//		Constructors / Destructors / Disposal / Copying / Creation			//
//									  																								//
////////////////////////////////////////////////////////////////////////

	CharBuffer();																												//	constructor
	CharBuffer(long newSize);																						//	sized constructor
	CharBuffer(char *newContents);																			//	constructor to take an existing string
	~CharBuffer();																											//	destructor

////////////////////////////////////////////////////////////////////////
//									  																								//
//	File Output:																											//
//									  																								//
////////////////////////////////////////////////////////////////////////
	
	void Write(char *newStuff);																					//	adds more stuff at the entry point
	char *ReadLine();																										//	returns a copy of the data from the entry point to 
																																			//	the next new line or null character.  Null-terminates
	bool EndOfBuffer();																									//	returns true iff the entry point is at the end
	long GetLong();																											//	retrieve a long value
	float GetFloat();																										//	retrieve a floating point value
	char *GetContents();																								//	strips out the contents & returns them
	char Lookahead();																										//	shows the next character as a lookahead
	};	// end of CharBuffer class	
