//	74.442	Advanced Design & Analysis of Algorithms
//	Spring 1998
//	Dr. Bill Kocay
//
//	Hamish Carr
//	Project:	Toroidal Surface Geometries
//
//


#pragma once

class TorusSettingsWindow;													//	forward declaration

#include "TorusWindow.h"

#define TSW_THETA_SET 3001L
#define TSW_PHI_SET 3002L
#define TSW_RINGRAD_SET 3003L
#define TSW_TUBERAD_SET 3004L
#define TSW_HELP_WANTED 3005L
#define TSW_CANCEL_IT 3006L
#define TSW_DO_IT 3007L

#define TSW_MIN_THETAS 4
#define TSW_MAX_THETAS 1000
#define TSW_MIN_PHIS 4
#define TSW_MAX_PHIS 1000

#define TSW_MIN_RINGRAD 0
#define TSW_MAX_RINGRAD 4000
#define TSW_MIN_TUBERAD 100
#define TSW_MAX_TUBERAD 1000

#define TSW_HELP_MESSAGE "Please choose the number of tiles you wish to use to render this torus.\n\n" \
						 "# of Theta Divisions refers to how many subdivisions there will be around the " \
						 "outside of the torus (i.e. around the ring).\n\n" \
						 "# of Phi Divisions refers to how many subdivisions there will be at any given " \
						 "location on the torus (i.e. around the tube)\n\n" \
						 "# of Theta Divisions should normally be greater than # of Phi Divisions.\n\n" \
						 "For best results, use factorials (4!, 5!, 6!).\n\n" \
						 "Tube & Ring Radius refer to the two radii that define the torus.\n\n" \
						 "For a *really* weird view, go inside a torus with ring radius < tube radius" 

class TorusSettingsWindow : public BWindow									//	a window for setting parameters for a torus
	{
	private:
	BButton *helpButton;													//	button for calling up a help dialog
	BButton *OKButton;														//	button for creating a new torus
	BButton *cancelButton;													//	button to cancel the creation
	BTextControl *thetaEntry;												//	text field in which to enter theta
	BTextControl *phiEntry;													//	text field in which to enter phi
	BTextControl *ringRadEntry;												//	text field in which to enter ring radius
	BTextControl *tubeRadEntry;												//	text field in which to enter tube radius

	long thetaDivs, phiDivs;												//	number of theta, phi divisions to use
	float ringRad, tubeRad;													//	radius of the ring and the tube

	public:	
	TorusSettingsWindow();													//	constructor
	~TorusSettingsWindow();													//	destructor
	
	void ResetTheta();														//	reset the theta value based on contents of box
	void ResetPhi();														//	ditto for phi
	void ResetRingRad();													//	do it for ring radius
	void ResetTubeRad();													//	and, inevitably, for tube radius
	virtual void MessageReceived(BMessage *theEvent);						//	processes messages
	}; // end of TorusWindow class
																			