//	74.442	Advanced Design & Analysis of Algorithms
//	Spring 1998
//	Dr. Bill Kocay
//
//	Hamish Carr
//	Project:	Toroidal Surface Geometries
//
//

#include "GCDLCM.h"

long GCD(long x, long y)										//	computes GCD of x, y
	{
	long big, little, remainder;								//	local values
	
	if (x > y)													//	if x is bigger
		{
		big = x; little = y;									//	start them off this direction
		} // end of x > y
	else														//	i.e. x <= y
		{
		big = y; little = x;									//	start them off with big = y
		} // end of x <= y
	
	while (true)												//	loop until we branch
		{
		remainder = big%little;									//	compute the remainder
		if (remainder == 0) return little;						//	we're done:  give the GCD back
		big = little;											//	step the little one up
		little = remainder;										//	and set the little one to the remainder
		} // end of loop
	} // end of GCD

long LCM(long x, long y)										//	computes LCM of x, y
	{
	long gcd = GCD(x, y);										//	compute the GCD of x, y
	return (x/gcd)*y;											//	compute the LCM	
	} // end of LCM