//	74.442	Advanced Design & Analysis of Algorithms
//	Spring 1998
//	Dr. Bill Kocay
//
//	Hamish Carr
//	Project:	Toroidal Surface Geometries
//
//

#include "TorusBlitView.h"

TorusBlitView::TorusBlitView(BRect theFrame, Torus *newTorus, BBitmap *newBlitMap)	//	constructor
	: BView(theFrame, "Torus Main View", B_FOLLOW_ALL, B_WILL_DRAW)			//	call inherited constructor
	{
	theTorus = newTorus;													//	copy the pointer
	theBlitMap = newBlitMap;												//	and the bitmap pointer
	} // end of TorusBlitView constructor

void TorusBlitView::Draw(BRect updateRect)									//	draw the torus
	{
	#pragma unused(updateRect)
//	FillRect(updateRect, B_SOLID_HIGH);										//	paint entire view in black
	theTorus->Render(this);													//	tell the torus to draw itself	
	Sync();																	//	wait for the server to draw it
	} // end of Draw()

void TorusBlitView::Generate()												//	regenerates the contents of the view
	{
	theBlitMap->Lock();														//	lock the blitmap first
	Draw(Bounds());															//	draw the entire bitmap
	theBlitMap->Unlock();													//	unlock the blitmap
	} // end of Generate()